#define MIN_AMS 101
#define SAVE_SCREEN
#define RETURN_VALUE
#include <all.h>
#define pause(s) {clrscr(); printf("%s",s); ngetchx();}

unsigned char stringToInt(const char *str, const char i);

void _main(void)
{
	clrscr();
	//-------------------------------------------------------------\\
	struct box
	{
		unsigned char tens, unit;
	};
	//-------------------------------------------------------------\\
	ESI q = top_estack;
	char *a = GetStrnArg(q), *b = GetStrnArg(q),
				dimA = strlen(a), dimB = strlen(b),
				d[abs(dimA - dimB)],
				horiz[dimA], vert[dimB],
				border[dimA + dimB],
				i, j, p, c;
	/*strcpy(d,"");
	if(dimA < dimB)
	{
		for(i=0; i<dimB-dimA; i++)
			strcat(d,"0");
		strcat(d,a);
		strcpy(a,d);
	}
	else if(dimA > dimB)
	{
		for(i=0; i<dimA-dimB; i++)
			strcat(d,"0");
		strcat(d,b);
		strcpy(b,d);
	}
	pause(a);
	pause(b);
	//return;*/
	//-------------------------------------------------------------\\
	struct box grid[dimA][dimB];
	for(i=0; i<dimA; i++)
	{
		horiz[i] = stringToInt(a,i);
		for(j=0; j<dimB; j++)
		{
			vert[j] = stringToInt(b,j);
			grid[j][i].tens = (p=horiz[i] * vert[j]) / 10;
			grid[j][i].unit = p % 10;
		}
	}
	
	//-------------------------------------------------------------\\
	for(i=0; i<dimB; i++)
	{
		c = grid[i][0].tens;
		j = 0;
		p = i;
		while(p > 0)
		{
			c += grid[--p][j].unit;
			c += grid[p][++j].tens;
		}
		border[i] = c;
	}
	
	for(i=dimB-1; i>=0; i--)
	{
		c = grid[i][dimA-1].unit;
		j = dimA-1;
		p = i;
		while(p < dimB - 1)
		{
			c += grid[++p][j].tens;
			c += grid[p][--j].unit;
		}
		border[i + dimB] = c;
	}
	//-------------------------------------------------------------\\
	for(i=dimA+dimB-1; i>=0; i--)
	{
		if(border[i] > 9) //border[i] is a two-digit number
		{
			border[i-1] += border[i] / 10;
			border[i] %= 10;	
		}
	}
	//-------------------------------------------------------------\\
	strcpy(a,"");
	strcpy(b,"");
	for(i=0; i<dimA+dimB; i++)
	{
		sprintf(b,"%d",border[i]);
		strcat(a,b);
	}
	push_zstr(a);
	push_END_TAG();
	for(i=0; i<dimA+dimB; i++)
		push_shortint(border[dimA+dimB-i-1]);
	push_LIST_TAG();
	//push_zstr(a);
	strcpy(a,"");
	strcpy(b,"");
}

unsigned char stringToInt(const char *str, const char i)
{
	return str[i] - 48;
}
